(*
**  ctl.inc
**
**  Structures for SETUP.FD
**
**  Copyright 1989-1997 Definite Solutions HB; All rights reserved.
**
**  Last revised: 97-11-21                          FrontDoor 2.25+
**
**  -------------------------------------------------------------------------
**  This information is not necessarily final and is subject to change at any
**  given time without further notice
**
**  Please note that some new global and mailer-specific data has been added
**  (94-05-31) to some rather inappropriate structures. This was done in
**  attempt to add capabilities without breaking current software that may
**  depend on the format of SETUP.FD. NOTE: The format of this file will
**  be completely revised for 3.00.
**  -------------------------------------------------------------------------
*)

CONST
  CURRPRGREV            =$94053100;

(*
**  Mailer ------------------------------------------------------------------
*)

    { Loglevels }

CONST
  LOGFATAL              =$0001;              {'!' Fatal errors}
  LOGERROR              =$0002;              {'?' Errors}
  LOGBRIEF              =$0004;              {'+' Major changes in action}
  LOGACCT               =$0008;              {'$' Accounting information}
  LOGXFER               =$0010;              {'*' Sent/Received files}
  LOGTRIVIAL            =$0020;              {'-' Minor changes in action}
  LOGXFERMSG            =$0040;              {'%' Transfer messages}
  LOGMODEM              =$0080;              {'=' Modem activities/responses}
  LOGTRX                =$0100;              {':' Session transaction numbers}
  LOGSESSION            =$0200;              {'~' Session stuff, SysOp, etc.}
  LOGRMTAKAS            =$0400;              {'~' Remote system's AKAs}
  LOGRMTINFO            =$0800;              {'~' Remote system's information}
  LOGUNEXPECT           =$1000;              {'#' Unexpected password}
  LOGFREQTRIV           =$2000;              {'`' Trivial FREQ messages}
  LOGDEBUG              =$8000;              {    All loglevels enabled}

    { Miscellaneous flags (FLAGS) }

  NOUNLISTED            =$00000001;             {Don't allow unlisted systems}
  CREATE_BATCH          =$00000002;         {Create batchfile when BBS caller}
  TERMONLY              =$00000004;                 {Running as Terminal-Only}
  DTR_HANGUP            =$00000008;                        {Use DTR to hangup}
  DTR_DIAL              =$00000010;              {Toggle DTR prior to dialing}
  DTR_BUSY              =$00000020;                   {Use DTR to signal BUSY}
  MANUAL_ANSWER         =$00000040;                        {Use manual answer}
  CONNECT_RESET         =$00000080;             {Reset modem to connect speed}
  MODEM_FIXED           =$00000100;         {Use constant speed against modem}
  NOMAIL_NOPWD          =$00000200;           {No mail from unsecured systems}
  MAILWAITFDUSERS       =$00000400;    {Mail waiting notice for FD users only}
  xxxxCLOCK             =$00000800;                           {!!!NOT USED!!!}
  KILLNULL              =$00001000;             {Remove messages with no text}
  MAILONLY              =$00002000;                {Don't allow human callers}
  xxxxLIMITEDANSW       =$00004000;                  {Limited hours to answer}
  EXIT_NETMAIL          =$00008000;               {Exit when netmail received}
  ZONE_ADAPTION         =$00010000;                {Adopt called/calling zone}
  PRINTNEWMSGS          =$00020000;                  {Print received messages}
  NOUNKNOWNPOINTS       =$00040000;             {Don't accept unlisted points}
  FORCEDCARRIER         =$00080000;         {Carrier is forced. Ring required}
  NULLMODEM             =$00100000;            {Initiate session when CD high}
  MAILER43LINES         =$00200000;            {Use 43/50 line mode in mailer}
  SWAPTOEMSDISK         =$00400000;        {Swap file to LIM/EMS/DISK w/shell}
  MAILEREMSOK           =$00800000;          {If EMS can be used for swapping}
  PRESENTAKAS           =$01000000;        {Present AKAs during EMSI sessions}
  NOBLINKMAIL           =$02000000;        {Don't flash the waiting mail sign}
  EXITONANYFILE         =$04000000;        {Exit after ANY data has been rcvd}
  MAILERAUTOLINES       =$08000000;        {Use whatever screen mode is there}
  HONOR_RRQ             =$10000000;                                {Honor RRQ}
  NO_TIMESTAMP          =$20000000;         {Don't show timestamp in window-1}
  MAILERCUSTOMCRT       =$40000000;                 {User-defined screen size}
  MAILERBBSONLY         =$80000000;   {Load BBS immediately upon inbound call}

    { Miscellaneous flags (FLAGS2) }

  FAXAUTORECEIVE        =$00000001;                 {Handle inbound fax calls}
  MAILERLOGDFRS         =$00000002;           {Log data following RING signal}
  MEXTFREQS             =$00000004;              {Use external file ReqServer}
  MEXTFREQNOSWAP        =$00000008;        {Don't swap when calling ReqServer}
  xxxxFAXAUTOPRINT      =$00000010;         {Auto print faxes (internal only)}
  MODEMNODIALISBUSY     =$00000020;          {Don't treat NO DIALTONE as RING}
  MODEMRINGINITOK       =$00000040;             {RING is OK when initializing}
  MODEMANSWERCOUNT      =$00000080;    {Manual answer, on specific RING count}
  FORCEKILLRRQ          =$00000100;    {Force RRQ receipts to be removed (ML)}
  ALLOWTSYNCNOUTC       =$00000200;    {Allow time synchronization w/o UTC(+)}
  MAILER28LINES         =$00000400;           {Use 28-line VGA mode in mailer}
  MAILER33LINES         =$00000800;           {Use 33-line VGA mode in mailer}
  STQORDERDEST          =$00001000;     {Sort STQ on destination initially(+)}
  STQORDERFILE          =$00002000;       {Sort STQ on filenames initially(+)}
  MAILERSCRIPTNOASK     =$00004000;    {Ignore .SCR files in Console services}

    { Audio flags }

  CLOCKNOISE            =$0001;                      {Tic-tac-tic-tac-tic-tac}
  INMAILNOISE           =$0002;                            {Unpacked any mail}
  INCRASHNOISE          =$0004;             {Unpacked crash or immediate mail}
  INCONNECTNOISE        =$0008;                 {Incoming MAIL call (connect)}
  INCALLERNOISE         =$0010;            {Incoming human caller passed >BBS}
  MAILWAITING           =$0020;                              {Mail is waiting}
  OUTMAILNOISE          =$0040;                    {Sent mail (after session)}
  OUTCONNECTNOISE       =$0080;                 {Outgoing MAIL call (connect)}
  ERRORNOISE            =$0100;                                       {S.O.S.}
  RINGNOISE             =$0200;                                {Incoming ring}

    { Request types }

  REQALL                =$01;                            {Anybody can request}
  REQNONE               =$02;                             {No one can request}
  REQLISTED             =$04;                            {Only listed systems}
  REQLIMITED            =$08;                                  {Limited hours}
  REQONLYONEWCARD       =$40;                {Stop after one match (wildcard)}
  REQONLYONEMATCH       =$80;                {Stop after one match (explicit)}

    { External mail flags }

  EXTM_HOT              =$01;                   {Leave FOSSIL "hot" upon exit}
  EXTM_INBOUND          =$02;                   {Trigger during inbound calls}
  EXTM_OUTBOUND         =$04;                  {Trigger during outbound calls}

TYPE
  _MAILER = RECORD
    Log         :ARRAY[1..71] OF CHAR;                          {Log filename}
    LogLevel    :WORD;                                         {See Loglevels}

    Prefix      :ARRAY[1..31] OF CHAR;                          {Always added}
    Hidden      :ARRAY[1..10] OF ARRAY[1..31] OF CHAR;
                                                {Strip these if they are in #}
    PostFix     :ARRAY[1..31] OF CHAR;                       {Always appended}

    Flags,                                           {See Miscellaneous flags}
    Flags2      :LONGINT;                            {See Miscellaneous flags}

    Audio       :WORD;                                       {See Audio flags}
    SynchTimer  :BYTE;                  {Number of seconds before drop to BBS}

    crashexit   :BYTE;                                             {Mail exit}
    BBSexit     :BYTE;                                          {Human caller}
    bbs1200     :BYTE;                                        {!!!NOT USED!!!}
    bbs1275     :BYTE;                                        {!!!NOT USED!!!}
    bbs2400     :BYTE;                                        {!!!NOT USED!!!}
    bbs4800     :BYTE;                                        {!!!NOT USED!!!}
    bbs9600     :BYTE;                                        {!!!NOT USED!!!}
    bbs19200    :BYTE;                                        {!!!NOT USED!!!}
    bbs38400    :BYTE;                                        {!!!NOT USED!!!}

    modembaud   :WORD;                                 {30=300, 24=2400, etc.}
    modemport   :BYTE;                          {1-255 (COM1=1, COM2=2, etc.)}
    modemdelay  :BYTE;                        {1/10 seconds delay / line sent}

    ConMsg      :ARRAY[1..5] OF
      RECORD
        Message :ARRAY[1..16] OF CHAR;                       {CONNECT message}
        Baudrate:LONGINT;                             {Corresponding baudrate}
      END;{ConMsg}
    ConnectPrefix:ARRAY[1..16] OF CHAR;                    {Usually "CONNECT"}
    BBSminBaudrate:LONGINT;                      {Minimum speed to access BBS}
    BBSmaxBaudrate:LONGINT;                      {Maximum speed to access BBS}
    RESERVEDlong:LONGINT;                                           {RESERVED}

    errormsg    :ARRAY[1..16] OF CHAR;                                 {ERROR}
    busymsg     :ARRAY[1..16] OF CHAR;                                  {BUSY}
    carriermsg  :ARRAY[1..16] OF CHAR;                            {NO CARRIER}
    okmsg       :ARRAY[1..16] OF CHAR;                                    {OK}
    ringmsg     :ARRAY[1..16] OF CHAR;                                  {RING}
    nodialmsg   :ARRAY[1..16] OF CHAR;                           {NO DIALTONE}
    noanswmsg   :ARRAY[1..16] OF CHAR;                             {NO ANSWER}
    voicemsg    :ARRAY[1..16] OF CHAR;                                 {VOICE}

    escapestr   :ARRAY[1..11] OF CHAR;                {Return to command mode}
    offhookstr  :ARRAY[1..11] OF CHAR;                             {Busy line}
    reconnectstr:ARRAY[1..11] OF CHAR;                   {Return to data mode}
    init1       :ARRAY[1..50] OF CHAR;                      {Initialization-1}
    init2       :ARRAY[1..50] OF CHAR;                      {Initialization-2}
    init3       :ARRAY[1..50] OF CHAR;                      {Initialization-3}
    resetstr    :ARRAY[1..50] OF CHAR;                   {Force "OK" response}
    downstr     :ARRAY[1..50] OF CHAR;                    {Sent upon shutdown}
    hangupstr   :ARRAY[1..11] OF CHAR;                               {On hook}
    dialstr     :ARRAY[1..11] OF CHAR;                                  {Dial}

    oldmodemanswer:ARRAY[1..11] OF CHAR;                      {!!!NOT USED!!!}
    answerdelay :BYTE;                          {1/10s delay before answering}

    begin_hour  :BYTE;                                        {!!!NOT USED!!!}
    begin_minute:BYTE;                                        {!!!NOT USED!!!}
    end_hour    :BYTE;                                        {!!!NOT USED!!!}
    end_minute  :BYTE;                                        {!!!NOT USED!!!}

    retrybusy   :BYTE;                              {Retry attempts when BUSY}
    retryresend :BYTE;                              {Retry attemps on failure}
    retrydelay  :BYTE;                                 {Seconds between calls}

    reqlist     :ARRAY[1..71] OF CHAR;         {List to scan for reqable dirs}
    reqalias    :ARRAY[1..71] OF CHAR;                       {Magic filenames}
    reqmessage  :ARRAY[1..71] OF CHAR;    {Appended to FAILED REQUEST message}
    reqtype     :BYTE;                                             {See below}
    reqmaxfiles :BYTE;                  {Max number of files to send on 1 req}
    reqmaxtime  :WORD;                     {Maximum number of minutes for req}
    reqmaxsize  :WORD;                          {Maximum size (in KB) for req}
    OLDrminbaud :WORD;                                        {!!!NOT USED!!!}
    reqstarthr  :BYTE;                  {Start time for file requests, can be}
    reqstartmin :BYTE;                     {..combined with the reqdays field}
    reqendhr    :BYTE;                            {End time for file requests}
    reqendmin   :BYTE;
    reqdays     :BYTE;                 { 7 6 5 4 3 2 1           $80=All days
                                         _ _ _ _ _ _ _
                                         : : : : : : :
                                         : : : : : : +--- Saturday
                                         : : : : : +----- Friday
                                         : : : : +------- Thursday
                                         : : : +--------- Wednesday
                                         : : +----------- Tuesday
                                         : +------------- Monday
                                         +--------------- Sunday            }

    bbsname     :ARRAY[1..11] OF CHAR;             {Press <Esc> for "bbsname"}
    beforebbsbanner:ARRAY[1..71] OF CHAR;       {File sent before drop to BBS}

    KEY         :ARRAY[1..24] OF                        {Mailer function keys}
      RECORD                                            {F1-F12, Shift F1-F12}
        Cmd     :ARRAY[1..61] OF CHAR;                    {Program to execute}
        Title   :ARRAY[1..26] OF CHAR;             {Title to appear on screen}
        Behavior:BYTE;                  {=$01-Pause, =$02-Rescan, =$04-NoSwap}
      END;{Record}

    Color       :ARRAY[1..11] OF BYTE;                      {Header
                                                             Highlight
                                                             Clock
                                                             Data entry
                                                             Error
                                                             Normal text
                                                             Frame
                                                             Window text
                                                             Window frame
                                                             Window select
                                                             Window highlight}

    KeepHistory :BYTE;                  {Days to keep entries in mail history}

    xxxSlavePwd :ARRAY[1..21] OF CHAR;                        {!!!NOT USED!!!}

    ineventfile :ARRAY[1..71] OF CHAR;      {Displayed to users when no users}
    BadBPSfile  :ARRAY[1..71] OF CHAR; {Displayed when connect speed isn't OK}

    ExternMail  :ARRAY[1..10] OF                     {External mail interface}
      RECORD
        WakeUpStr  :ARRAY[1..39] OF CHAR;             {String to trigger exit}
        Flags      :BYTE;                             {See EXTM_* flags above}
        Errorlevel :BYTE;                            {Errorlevel to exit with}
      END;{Record}

    audio_begin_hour:BYTE;                    {Start and end of audio allowed}
    audio_begin_minute:BYTE;                    {If all four fields are zero,}
    audio_end_hour:BYTE;                     {..audio is allowed at all times}
    audio_end_minute:BYTE;

    min_undial_cost:WORD;                            {Minimum undialable cost}

    CDMASK      :BYTE;                              {Carrier detect mask (ML)}

    SETUPFDTimestamp:
                 LONGINT;                      {When file was last written to}

    reqseclist  :ARRAY[1..71] OF CHAR;         {List to scan for reqable dirs}
                                              {...during SECURE sessions (ML)}

    bbs7200     :BYTE;                                        {!!!NOT USED!!!}
    bbs12000    :BYTE;                                        {!!!NOT USED!!!}
    bbs14400    :BYTE;                                        {!!!NOT USED!!!}

    SETcustomcrt_AX,                              {INT 10H register values to}
    SETcustomcrt_BX,                             {set CUSTOM screen mode (ML)}
    SETcustomcrt_CX,
    SETcustomcrt_DX
                :WORD;

    RESETcustomcrt_AX,                            {INT 10H register values to}
    RESETcustomcrt_BX,                         {reset CUSTOM screen mode (ML)}
    RESETcustomcrt_CX,
    RESETcustomcrt_DX
                :WORD;

    reqsecalias :ARRAY[1..71] OF CHAR;            {Magic filenames for SECURE}
                                                               {sessions (ML)}

    modemanswer :ARRAY[1..41] OF CHAR;              {Instruct modem to answer}
    ModemAnswer2:ARRAY[1..41] OF CHAR;              {Instruct modem to answer}
    RESERVEDchar:ARRAY[1..7] OF CHAR;                               {RESERVED}

    b16800msg   :ARRAY[1..16] OF CHAR;                        {!!!NOT USED!!!}
    bfaxmsg     :ARRAY[1..16] OF CHAR;                           {CONNECT FAX}

    bbs16800    :BYTE;                                        {!!!NOT USED!!!}
    bbsfax      :BYTE;                                   {FAX call errorlevel}

    InboundFaxPath:ARRAY[1..71] OF CHAR;               {Inbound fax path (ML)}

    FReqServer  :ARRAY[1..71] OF CHAR;          {External file request server}

    b57600msg   :ARRAY[1..16] OF CHAR;                        {!!!NOT USED!!!}
    b64000msg   :ARRAY[1..16] OF CHAR;                        {!!!NOT USED!!!}
    b115200msg  :ARRAY[1..16] OF CHAR;                        {!!!NOT USED!!!}

    bbs57600    :BYTE;                                        {!!!NOT USED!!!}
    bbs64000    :BYTE;                                        {!!!NOT USED!!!}
    bbs115200   :BYTE;                                        {!!!NOT USED!!!}

    ModemCustomMsg:ARRAY[1..16] OF CHAR;                      {!!!NOT USED!!!}
    ModemCustomBaud:LONGINT;                                  {!!!NOT USED!!!}
    bbsCustom   :BYTE;                                        {!!!NOT USED!!!}

    reqminbaud  :LONGINT;                  {Minimum baudrate for file request}

    MailExitSemaphore:ARRAY[1..71] OF CHAR;        {Touched/created when mail}
                                                      {has been received (ML)}
    xxxFaxPrinter:ARRAY[1..71] OF CHAR;                       {!!!NOT USED!!!}
    b21600msg   :ARRAY[1..16] OF CHAR;                        {!!!NOT USED!!!}
    b24000msg   :ARRAY[1..16] OF CHAR;                        {!!!NOT USED!!!}
    b26400msg   :ARRAY[1..16] OF CHAR;                        {!!!NOT USED!!!}
    b28800msg   :ARRAY[1..16] OF CHAR;                        {!!!NOT USED!!!}
    bbs21600    :BYTE;                                        {!!!NOT USED!!!}
    bbs24000    :BYTE;                                        {!!!NOT USED!!!}
    bbs26400    :BYTE;                                        {!!!NOT USED!!!}
    bbs28800    :BYTE;                                        {!!!NOT USED!!!}

    RingingCount:BYTE;                   {Number of RINGING before dial abort}

    b31200msg   :ARRAY[1..16] OF CHAR;                        {!!!NOT USED!!!}
    b33600msg   :ARRAY[1..16] OF CHAR;                        {!!!NOT USED!!!}
    bbs31200    :BYTE;                                        {!!!NOT USED!!!}
    bbs33600    :BYTE;                                        {!!!NOT USED!!!}
    exitVoice   :BYTE;                              {CONNECT VOICE errorlevel}

    FDSERVERPwdCRC1,                       {FDSERVER pwd, $ffffffff==disabled}
    FDSERVERPwdCRC2:                       {FDSERVER pwd, $4f8bc2b6==disabled}
                 LONGINT;                    
    RESERVERAT  :ARRAY[1..257] OF CHAR;                             {RESERVED}
  END;{_MAILER}

{*
**  Editor ------------------------------------------------------------------
*}

    { Miscellaneous flags (FLAGS) }

CONST
  EDITOR43LINES         =$00000001;                      {Use 43/50-line mode}
  SHOWHARDCRS           =$00000002;         {Display paragraph (hard CR) char}
  EDITORSWAP            =$00000004;          {Swap to LIM/EMS/DISK when shell}
  EDITOREMSOK           =$00000008;                    {EMS OK for swap image}
  EDITORAUTOLINES       =$00000010;        {Use whatever screen mode is there}
  HONOR_CFM             =$00000020;                                {Honor CFM}
  EDITORCUSTOMCRT       =$00000040;                 {User-defined screen size}
  RKILL_NEVER_E         =$00000080;           {Never ask "Delete Original?"-E}
  RKILL_NEVER_L         =$00000100;           {Never ask "Delete Original?"-L}
  RKILL_NEVER_N         =$00000200;           {Never ask "Delete Original?"-N}
  EDITORHILSURV         =$00000400;         {Highlight new messages in Survey}
  EDITORHILSURVMY       =$00000800;      {Highlight messages to/from user -"-}
  NEWMSGSEM             =$00001000;     {Semaphores when new msgs are created}
  FAXAUTOVIEW           =$00002000;         {View fax documents automatically}
  FAXAUTOKILL           =$00004000;   {Remove fax document with cover message}
  FORCEKILLCFM          =$00008000;         {Force CFM receipts to be removed}
  RKILL_ASKY_E          =$00010000;   {Ask "Delete Original?" w/Yes default-E}
  RKILL_ASKY_L          =$00020000;   {Ask "Delete Original?" w/Yes default-L}
  RKILL_ASKY_N          =$00040000;   {Ask "Delete Original?" w/Yes default-N}
  EDITORHTIMENET        =$00080000;    {Set time on NetMail messages to 00:00}
  EDITORHTIMENNET       =$00100000;{Set time on non-NetMail messages to 00:00}
  EDITORNOTEARL         =$00200000;           {Create * Origin: w/o tear-line}
  EDITORDEFDELSPY       =$00400000;        {Default response to Survey delete}
  EDITORQUOTELC         =$00800000;                 {Lowercase quote initials}
  EDITORQUOTEUC         =$01000000;                 {Uppercase quote initials}
  EDITORNOSTRIPRE       =$02000000; {Prevent stripping of "Re:" when replying}
  EDITORNOUSEREPLIEDTO  =$04000000; {Don't use "IsReturn" bit for "RepliedTo"}
  EDITORSELECTUSER      =$08000000;       {Always force user selection dialog}
  EDITORSHSUSELECT      =$10000000; {Show if message is selected in Surv-List}
  EDITOR28LINES         =$20000000;           {Use 28-line VGA mode in Editor}
  EDITOR33LINES         =$40000000;           {Use 33-line VGA mode in Editor}
  FAXAUTOKILLASK        =$80000000;     {Prompt to kill fax document w/CvrMsg}

                                 
    {Netmail folder behavior}

  RESTRICTED            =$00000001;                             {See FOLDER.H}
  EXPORTOK              =$00000004;
  USEXLATTABLES         =$00000008;
  EDREADONLY            =$00000020;

TYPE
  _EDITOR = RECORD
    MacroKey    :ARRAY[1..24] OF ARRAY[1..61] OF CHAR;  {F1-F12, Shift F1-F12}

    margin      :BYTE;                           {Wordwrap margin, default=60}

    msgbits     :WORD;                        {Default NetMail message status}

    flags       :LONGINT;                                          {See above}

    Origin      :ARRAY[1..20] OF ARRAY[1..61] OF CHAR;          {Origin lines}

    color       :ARRAY[1..15] OF BYTE;                  {Top line
                                                         Status line
                                                         Error
                                                         Message text
                                                         Quoted message text
                                                         Reverse message text
                                                         Hard <CR>s
                                                         Message header
                                                         Message header data
                                                         Header data highlight
                                                         Input fields
                                                         Window frame
                                                         Window text
                                                         Window select
                                                         Window highlight}

    netfolderflags:LONGINT;                             {NetMail folder flags}

    translate_in:ARRAY[1..256] OF CHAR;          {Translation table (reading)}
    translate_out:ARRAY[1..256] OF CHAR;         {Translation table (writing)}

    qbase       :ARRAY[1..71] OF CHAR;     {Path to Hudson Message Base (HMB)}

    SETcustomcrt_AX,                              {INT 10H register values to}
    SETcustomcrt_BX,                             {set CUSTOM screen mode (ML)}
    SETcustomcrt_CX,
    SETcustomcrt_DX
                :WORD;

    RESETcustomcrt_AX,                            {INT 10H register values to}
    RESETcustomcrt_BX,                         {reset CUSTOM screen mode (ML)}
    RESETcustomcrt_CX,
    RESETcustomcrt_DX
                :WORD;

    FaxViewer   :ARRAY[1..71] OF CHAR;            {Program invoked by <A> (+)}
    FileViewer  :ARRAY[1..71] OF CHAR;            {Program invoked by <V> (+)}
    HMBbbsPath  :ARRAY[1..71] OF CHAR;     {ECHOMAIL.BBS/NETMAIL.BBS location}
    JAMbbsPath  :ARRAY[1..71] OF CHAR;     {ECHOMAIL.JAM/NETMAIL.JAM location}

    RESERVERAT  :ARRAY[1..724] OF CHAR;                             {RESERVED}
  END;{_EDITOR}

{*
**  Shared data -------------------------------------------------------------
*}

    { Miscellaneous flags (FLAGS) }

CONST
  FASTKEY               =$00000001;                 {Set/reset typematic rate}
  FLICKER               =$00000002;          {Prevent flicker on CGA monitors}
  BLACKOUT              =$00000004;                    {Screen blanker active}
  HAVEEXTKBD            =$00000008;      {Use extended INT 16H keyboard calls}
  xxFORCE24HOUR         =$00000010;                                 {Not used}
  MONOMODE              =$00000020;              {Monochrome mode for FDSETUP}
  DATEFMTUSA            =$00000040;                                 { m/dd/yy}
  DATEFMTEUR            =$00000080;                                 { d/mm/yy}
  DATEFMTMIL            =$00000100;                                 {yy-mm-dd}
  TIMEFMT12H            =$00000200;                                 {hh:mma/p}
  TIMEFMT24H            =$00000400;                                    {hh:mm}
  INHIBITBLINK          =$00000800;     {Inhibit blink attribute upon startup}
  RESETBLINK            =$00001000;                 {Reset blinking upon exit}

    { User flags }

  SUPERUSER             =$00000001;
  ADMINUSER             =$00000002;
  USER                  =$00000004;
  USERUILNOVICE         =$00000100;                          {Novice UIL (ML)}
  USERUILINTERM         =$00000200;                    {Intermediate UIL (ML)}
  USERLOCKUIL           =$00000400;              {Don't allow UIL change (ML)}
  BYPASSRO              =$00010000;             {Bypass Read-only restriction}
  BYPASSEXP             =$00020000;                {Bypass Export restriction}

    { Mailer Console Protection flags (ML) }

  FD_MCPROT_EXIT        =$00000001;            {Programs menu: Quit}
  FD_MCPROT_SHELL       =$00000002;            {Programs menu: DOS shell}
  FD_MCPROT_KEYS        =$00000004;            {Programs menu: User keys}
  FD_MCPROT_EDITOR      =$00000008;            {Programs menu: Message editor}
  FD_MCPROT_TERMINAL    =$00000010;            {Programs menu: Terminal}
  FD_MCPROT_SETUP       =$00000020;            {Programs menu: Setup}
  FD_MCPROT_NODELIST    =$00000040;            {Programs menu: Nodelist}
  FD_MCPROT_UTILITY     =$00000080;            {Utilities menu options}
  FD_MCPROT_MAIL        =$00000100;            {Mail menu options}
  FD_MCPROT_PROFILE     =$00000200;            {Your profile menu options}

    { FTN-Domain structure }

TYPE
  _DOMAIN = RECORD
    Zone,
    Reserved    :WORD;                                       {Zone for domain}
    Name        :ARRAY[1..28] OF CHAR;                        {Name of domain}
  END;{_DOMAIN}

    { AKA matching structure }

  _ZMATCH = RECORD
    Zone,                                                      {Zone to match}
    Net         :WORD;                                          {Net to match}
    AkaNum      :WORD;                             {AKA to use, 0=Primary AKA}
  END;{_ZMATCH}

  _SHARED = RECORD
    systempath  :ARRAY[1..71] OF CHAR;                           {SYSTEM path}
    mailpath    :ARRAY[1..71] OF CHAR;                 {System NetMail folder}
    swap_path   :ARRAY[1..71] OF CHAR;                   {Path for swap files}
    rescanpath  :ARRAY[1..71] OF CHAR;                  {Semaphore files (ML)}
    infilesecpath:ARRAY[1..71] OF CHAR;          {Rcvd files, SECURE sessions}
    infilepath  :ARRAY[1..71] OF CHAR;                            {Rcvd files}
    packetpath  :ARRAY[1..71] OF CHAR;          {Path for outbound .PKT files}
    nodelistpath:ARRAY[1..71] OF CHAR;            {Path for nodelist database}

    countrycode :WORD;                  {Country code for tel.no. translation}

    AKA : ARRAY[1..11] OF                   {One primary address and ten AKAs}
      RECORD
        Zone,
        Net,
        Node,
        Point   :WORD;
      END;{Record}

    flags       :LONGINT;                                          {See above}

    blackout_time:BYTE;                      {Screen blanker timer in seconds}

    { User record }

    Users : ARRAY[1..10] OF                                            {Users}
      RECORD
        Name    :ARRAY[1..31] OF CHAR;                              {Username}
        DefAKA  :INTEGER;                               {Default AKA for user}
        UserID  :LONGINT;                            {UserID for JAM LastRead}
        PwdCRC  :LONGINT;                {CRC-32 of user password, -1L No pwd}
        Flags   :LONGINT;                              {User flags, see above}
      END;{Record}

    exitpwdcrc  :LONGINT;           {Mailer Console Protection password  (ML)}
    exitflags   :LONGINT;                       {Actions to be protected (ML)}

    Zmatch      :ARRAY[1..20] OF _ZMATCH;                 {AKA matching table}
    Domain      :ARRAY[1..20] OF _DOMAIN;                   {FTN domain table}

    SiteInfo : RECORD                                       {Site information}
      Name      :ARRAY[1..50] OF CHAR;                        {Name of system}
      Location  :ARRAY[1..40] OF CHAR;                    {Location of system}
      PhoneNo   :ARRAY[1..26] OF CHAR;       {Phone number or '-Unpublished-'}
      Baudrate  :LONGINT;                             {Baud rate (300-115200)}
      Flags     :ARRAY[1..50] OF CHAR;            {Capability flags of system}
    END;{SiteInfo}

    FaxRecipient:WORD;                          {Fax recipient (0-based) (ML)}
    SemaphoreTimer:BYTE;                    {Seconds between semaphore checks}

    RESERVED    :ARRAY[1..76] OF CHAR;                              {RESERVED}
    FDSmajver   :BYTE;                        {Major version number [FDSETUP]}
    FDSminver   :BYTE;                        {Minor version number [FDSETUP]}
    FDSmultiline:BYTE;                                   {MultiLine indicator}
    CurrPrgRevLev:LONGINT;                                        {CURRPRGREV}
  END;{_SHARED}

{*
**  Terminal ----------------------------------------------------------------
*}

    { Miscellaneous flags (FLAGS) }

CONST
  CONNECT_NOISE         =$00000001;                    {Make noise on connect}
  TRANSFER_NOISE        =$00000002;                {Make noise after transfer}
  USE_TRANSLATE         =$00000004;                   {Use translation tables}
  USE_43LINES           =$00000008;                      {Use 43/50-line mode}
  AUTOZMODEM            =$00000010;              {Allow auto-Zmodem downloads}
  NOWRAPAROUND          =$00000020;               {Disable automatic wrapping}
  LOCALECHO             =$00000040;                  {Echo local input to CRT}
  NOAVATAR              =$00000080;                {Disable AVATAR/0+ support}
  USE_AUTOLINES         =$00000100;       {Use whatever screen mode is active}
  NOCLRONFF             =$00000200;         {Don't clear screen on form feeds}
  IEMSIACTIVE           =$00000400;                 {Interactive EMSI Support}
  TERMCUSTOMCRT         =$00000800;            {User-defined screen size (ML)}
  TERMLOG               =$00001000;                 {Logging in Terminal (ML)}
  TERMAUTODWMODE        =$00002000;                        {Auto Doorway Mode}
  TERMTIMERON           =$00004000;     {Inactivity timer to return to Mailer}
  TERMBSIBS             =$00008000;      {Backspace sends BS (instead of DEL)}
  TERMCURSORMED         =$00010000;                       {Medium-size cursor}
  TERMCURSORBIG         =$00020000;                        {Large-size cursor}
  USE_LATIN1_XLAT       =$00040000;               {Use ISO Latin1 translation}
  USE_28LINES           =$00080000;         {Use 28-line VGA mode in Terminal}
  USE_33LINES           =$00100000;         {Use 33-line VGA mode in Terminal}
  TERMSCRIPTNOASK       =$00200000;       {Ignore .SCR files in Nodelist dial}

TYPE
  _TERMINAL = RECORD
    InitString  :ARRAY[1..41] OF CHAR;                  {Modem initialization}

    ScrollSize  :WORD;                 {Maximum memory (kb) for scroll buffer}

    emulation   :BYTE;                        {0=TTY, 1=ANSI, 2=VT52, 3=VT100}

    protocol    :BYTE;                       {Default file transfer protocol}

    ShiftKey    :ARRAY[1..12] OF ARRAY[1..31] OF CHAR;          {Shift F1-F12}
    CtrlKey     :ARRAY[1..12] OF ARRAY[1..31] OF CHAR;           {Ctrl F1-F12}

    downloadpath:ARRAY[1..60] OF CHAR;                 {Default download path}
    uploadpath  :ARRAY[1..60] OF CHAR;                   {Default upload path}

    translate_in:ARRAY[1..256] OF CHAR;            {Inbound translation table}
    translate_out:ARRAY[1..256] OF CHAR;          {Outbound translation table}

    retrywait   :BYTE;                      {Seconds to wait before next dial}

    flags       :LONGINT;                                           {See above}

    directorypwd:LONGINT;              {CRC-32 of password to enter phone dir}

    editor      :ARRAY[1..60] OF CHAR;          {Program to invoke on <Alt-I>}

    profile     :ARRAY[1..94] OF CHAR;       {Default profile, see TERMINAL.H}

    SETcustomcrt_AX,                              {INT 10H register values to}
    SETcustomcrt_BX,                             {set CUSTOM screen mode (ML)}
    SETcustomcrt_CX,
    SETcustomcrt_DX
                :WORD;

    RESETcustomcrt_AX,                            {INT 10H register values to}
    RESETcustomcrt_BX,                         {reset CUSTOM screen mode (ML)}
    RESETcustomcrt_CX,
    RESETcustomcrt_DX
                :WORD;

    MailerTimer :LONGINT;                   {Inactivity timer (1/10s) setting}
    CaptureFN   :ARRAY[1..60] OF CHAR;              {Default Capture Filename}

    RESERVERAT  :ARRAY[1..573] OF CHAR;                             {RESERVED}

    VT100Colors :ARRAY[1..8] OF BYTE;                  {VT-100 CRT attributes}

    InitAddon   :ARRAY[1..19] OF CHAR;           {Add-on modem initialization}
    NewBBSName  :ARRAY[1..30] OF CHAR;                  {Name of BBS software}

    AKA         :ARRAY[1..20] OF RECORD                            {More AKAs}
                   Zone,
                   Net,
                   Node,
                   Point :WORD;
                 END;
  END;{_TERMINAL}

{*
**  Printer -----------------------------------------------------------------
*}

    { Miscellaneous flags (BEHAVIOR) }

CONST
  PAGE_FORMAT           =$00000001;
  PAGE_FFEED            =$00000002;
  EJECT                 =$00000004;
  MANUAL_PAPER          =$00000008;
  HIDE_KLUDGE           =$00000010;
  CONTINOUS             =$00000020;
  PRN_AUTOPRNFAX        =$00000040;      {Automatically print rcvd faxes (ML)}
  PRN_DISABLED          =$00000080;      {Printer disabled               (ML)}

TYPE
  _PRINTER = RECORD
    Port        :BYTE;                {0=LPT1, 1=LPT2, 2=LPT3, 3=COM1, 4=COM2}
    Baudrate    :BYTE;      {0=38400, 1=19200, 2=9600, 3=4800, 4=2400, 5=1200}
    stopbits    :BYTE;                                              {0=1, 1=2}
    wordlength  :BYTE;                                              {0=7, 1=8}
    parity      :BYTE;                                 {0=Even, 1=Odd, 2=None}
    pagelen     :BYTE;                           {Number of lines on one page}
    behavior    :LONGINT;                                          {See above}
    init        :ARRAY[1..71] OF CHAR;                           {Initialization}
    reset       :ARRAY[1..71] OF CHAR;                        {Deinitialization}
    bold_on     :ARRAY[1..31] OF CHAR;
    bold_off    :ARRAY[1..31] OF CHAR;
    under_on    :ARRAY[1..31] OF CHAR;
    under_off   :ARRAY[1..31] OF CHAR;
    italic_on   :ARRAY[1..31] OF CHAR;
    italic_off  :ARRAY[1..31] OF CHAR;
    pagewidth   :BYTE;                            {Width in columns of a page}
    leftmargin  :BYTE;                                           {Left margin}
    footer      :BYTE;                     {Footer margin, ie. leave nn lines}
    header      :BYTE;                      {Header margin, ie. skip nn lines}
    translate_out:ARRAY[1..256] OF CHAR;                   {Translation table}
    FaxPrinter  :ARRAY[1..71] OF CHAR;            {Program to invoke to print}
                                                          {a received fax (+)}
    Reserved    :ARRAY[1..29] OF CHAR;                              {RESERVED}
  END;{_PRINTER}

{*
**  SETUP.FD ----------------------------------------------------------------
**
** Don't use ANY of the data in the file if the CRC values are NOT correct.
**
** Check the fingerprint[] field before assuming 1.99b and higher. Your
** software should also check the sysrev field to make sure it's compatible
** with the data listed in SETUP.FD
*}

  {Current system file revision level}

CONST
  FD_THISREV            =$0100;

TYPE
  _CTL = RECORD
    FingerPrint :ARRAY[1..5] OF CHAR;               {Must contain "JoHo<NUL>"}
    sysrev      :WORD;                            {Must contain THISREV above}
    ctlcrc      :LONGINT;              {CRC-32 of _ctl excluding 1st 11 bytes}
    m           :_MAILER;
    e           :_EDITOR;
    s           :_SHARED;
    t           :_TERMINAL;
    p           :_PRINTER;
    ctlcrc2     :LONGINT;                            {CRC-32 of all the above}
  END;{_CTL}

{end of file "ctl.inc"}
