(*
**  folder.inc
**
**  Structures for FOLDER.FD
**
**  Copyright 1991-1997 Definite Solutions HB; All rights reserved.
**
**  Last revised: 97-11-21                          FrontDoor 2.25+
**
**  -------------------------------------------------------------------------
**  This information is not necessarily final and is subject to change at any
**  given time without further notice
**  -------------------------------------------------------------------------
*)

    { PATH and TITLE are NUL terminated, a'la C ASCIIZ strings. }

TYPE
  FOLDER      =RECORD
    MsgPath   :ARRAY[1..65] OF CHAR;    {Path if not HMB/JAM, otherwise emtpy}
    Title     :ARRAY[1..41] OF CHAR;               {Title to appear on screen}
    OriginNum :BYTE;                               {Default origin line, 0-19}
    Flags     :LONGINT;                                     {Flags, see below}
    PwdCRC    :LONGINT;              {CRC32 of password or -1L if unprotected}
    UserMask  :LONGINT;                 {Users with initial access, see below}
    UseAKANum :BYTE;                                   {AKA to use, 0=Primary}
    BoardNum  :WORD;                                        {HMB board number}
  END;{FOLDER}

  { Constant long bit values }

CONST
  FOLDER_RESTRICT       =$00000001;                        {Restricted folder}
  FOLDER_ECHOINFO       =$00000002;                  {Add Origin: information}
  FOLDER_EXPORTOK       =$00000004;        {OK for user to export from folder}
  FOLDER_USEXLAT        =$00000008;                   {Use translation tables}
  FOLDER_PRIVATE        =$00000010;               {Add Private message status}
  FOLDER_READONLY       =$00000020;                      {Folder is read-only}
  FOLDER_FORCEHARDCR    =$00000040;          {Force hard CRs at linebreak (C)}
  FOLDER_NEWSGROUP      =$00000080;   {Special treatment of some message data}
  FOLDER_REPLYTONMF     =$00000100;       {'R'eply key goes to NetMail Folder}
  FOLDER_SEPARATOR      =$00000200;                                {Separator}
  FOLDER_LOCKORIG       =$00000400;{Do not allow origin to be selected/chosen}
  FOLDER_NEWIFANY       =$00800000;     {Show "new" indicator if ANY messages}
  FOLDER_JAM            =$01000000;                  {JAM message base folder}
  FOLDER_NOCHECK        =$02000000;          {Exclude from new mail check (C)}
  FOLDER_NETMAIL        =$08000000;                  {Netmail-type folder (C)}
  FOLDER_HMB            =$10000000;               {Hudson Message Base folder}
  FOLDER_DELETED        =$20000000;                    {Never written to disk}
  FOLDER_LOCAL          =$40000000;                        {Local-type folder}
  FOLDER_ECHOMAIL       =$80000000;                   {Conference-type folder}

  { User access mask }

  FOLDER_USER_1         =$00000001;
  FOLDER_USER_2         =$00000002;
  FOLDER_USER_3         =$00000004;
  FOLDER_USER_4         =$00000008;
  FOLDER_USER_5         =$00000010;
  FOLDER_USER_6         =$00000020;
  FOLDER_USER_7         =$00000040;
  FOLDER_USER_8         =$00000080;
  FOLDER_USER_9         =$00000100;
  FOLDER_USER_10        =$00000200;

(* end of file "folder.inc" *)
