/*
**  modem.h
**
**  Structures for MODEM.FD
**
**  Copyright 1991-1997 Definite Solutions HB; All rights reserved.
**
**  Last revised: 97-11-21                          FrontDoor 2.11+
**
**  -------------------------------------------------------------------------
**  This information is not necessarily final and is subject to change at any
**  given time without further notice
**  -------------------------------------------------------------------------
*/
#ifndef __MODEM_H__
#define __MODEM_H__

#ifdef __cplusplus
extern "C" {
#endif

    /* Miscellaneous flags (FLAGS) */

#define MODEM_MAXENTRY  256              /*Maximum number of entries in list*/
#define MODEM_INACTIVE  0x0001                     /*Ignore string, inactive*/
#define MODEM_NODIAL    0x0002                     /*Don't dial system, ever*/
#define MODEM_STOPSCAN  0x0004           /*Stop scanning (and start dialing)*/
#define MODEM_DELETED   0x8000                       /*Never written to disk*/

typedef struct _ctlFDModemActRec
    {
    char                matchstr[24];                      /*String to match*/
    char                sendstr[32];                        /*String to send*/
    unsigned short int  flags;                                   /*See above*/
    }
    ctlFDModemActRec;

#ifdef __cplusplus
}
#endif
#endif

/* end of file "modem.h" */
